clear all
close all
clc


%------------------------Uivatelsk zadn dat----------------------------
%Vbr kanlu 
%Elektrody={'Fp1';'Fp2';'F7';'F3';'Fz';'F4';'F8';'T3';'C3';'Cz';'C4';'T4';'T5';'P3';'Pz';'P4';'T6';'O1';'O2';'A1';'A2';};
y=17;  
% Dlka okna 
okno=128;
%Prh detekce 
prah_zadany=0.05;


%------------------------Naten signlu-----------------------------------
[vystup1,chans,sampling,sens,chann,id,pr,jm,date,time]=filter_eeg(y);
kanal=vystup1;


%-----------------------Deklarace promnnch-------------------------------
% Vzorkovac frekvence
fvz=sampling;
%Reln polohy segment
real_polohy=[992,5312,9600,13856,17968,19920,20032,24384,28384,33328];
% Dlka signlu
delka=length(kanal);



%-----------------------Vpoet diference pomoc FFT-----------------------
for i=1:delka-2*okno
    okno1=kanal(i:i+okno);          %Naten oken
    okno2=kanal(i+okno:i+okno*2);
    
    okno1_fft=fft(okno1);           %Vpoet FFT
    okno2_fft=fft(okno2);
    okno1_fft=abs(okno1_fft);
    okno2_fft=abs(okno2_fft);
    
    
    diference(i)=(max((1/2)*((okno1_fft./okno2_fft)+(okno2_fft./okno1_fft))-1)); %Vpoet diference
    
  
    
end



%----------------------Aplikace prahu a uren loklnho maxima------------
N = length( diference );   
prah = prah_zadany*max(diference);
x=1000;                     % delka okna pro hledani maxima
index = 1+x;          
polohy = [];        
delka_okna = x;    
while index<N-delka_okna

    if diference(index)>prah, % Aplikace prahu
    
        kus = diference(index-delka_okna:index+delka_okna);   % Naten sti signlu pro nalezen maxima
        [hodnota,poloha] = max( kus );      % Nalezen maxima
        polohy = [polohy, (index-delka_okna)+poloha];    % Uloen polohy maxima
        index = index + delka_okna;         % Posunut o dlku okna
        
    else 

        index = index + 1;
        
    end
    
end
     

    
%----------------------Vykreslen------------------------------------------
figure(2);
subplot(3,1,1);
plot(linspace(0,delka/fvz,delka),kanal);
hold on;
stem( real_polohy/fvz, 400*ones(1,length(real_polohy)), 'r' );
hold off;
title('Pvodn signl s relnmi segmenty');
xlabel('as [s]')
ylabel('Amplituda [uV]')
hold on;
subplot(3,1,2);
plot(linspace(0,N/fvz,N),diference);
title('Mra diference');
xlabel('as [s]')
ylabel('Diference ')
hold on;
plot(1:delka/fvz,prah,'k')
subplot(3,1,3);
plot( linspace(0,delka/fvz,delka),kanal);
hold on;
stem( polohy/fvz, 400*ones(1,length(polohy)), 'k' );
hold on;
stem( real_polohy/fvz, 400*ones(1,length(real_polohy)), 'r' );
hold off;
title('Detekovan segmenty EEG')
xlabel('as [s]')
ylabel('Amplituda [uV]')



